> module MPlay		
> where                 

> import Haskore
> import MIL
> import System
> import Ratio

> il2music v (ILNote ton dur) = Note (toPitch ton) dur [Volume (fromIntegral v)] where
>   toPitch ton = (cla, oct) where
>      oct = ton `div` 12
>      cla = toCla (ton `mod` 12)
>      toCla 0 = C
>      toCla 1 = Cs  
>      toCla 2 = D
>      toCla 3 = Ds  
>      toCla 4 = E  
>      toCla 5 = Es  
>      toCla 6 = Fs  
>      toCla 7 = G  
>      toCla 8 = Gs  
>      toCla 9 = A 
>      toCla 10 = As  
>      toCla 11 = B  
>      toCla 12 = Bs


> il2music v (ILPause dur) = Rest dur
> il2music v (a :**: b)    = il2music v a :+: il2music v b
> il2music v (a :++: b)    = il2music v a :=: il2music v b
> il2music v (ILInstr i m) = Instr (toi i) (il2music v m) where
>          toi instr          = fst$genMidiMap!!(fromEnum instr)

> musik2music = (il2music 80). musik2IL -- 80 Standard Volume

> genMidi' m f = outputMidiFile f (testMidi (musik2music m))


