module Musik where
import Ratio

infixr 5 :+:, :=:

type GanzeZahl  = Int          -- Ganze Zahlen und Brueche setzen wir
type Bruch      = Ratio Int    -- als gegeben voraus.

type Ton        = GanzeZahl
type Dauer      = Bruch

data Musik      = Note Ton Dauer          |
                  Pause Dauer             |
                  Musik :+: Musik         |
                  Musik :=: Musik         |
                  Instr Instrument Musik
       deriving (Show, Eq)

data Instrument = 
 AcousticGrandPiano | BrightAcousticPiano | 
 ElectricGrandPiano | HonkyTonkPiano | 
 RhodesPiano | ChorusedPiano | 
 Harpsichord | Clavinet | 
 Celesta | Glockenspiel | 
 MusicBox | Vibraphone | 
 Marimba | Xylophone | 
 TubularBells | Dulcimer | 
 HammondOrgan | PercussiveOrgan | 
 RockOrgan | ChurchOrgan | 
 ReedOrgan | Accordion | 
 Harmonica | TangoAccordion | 
 AcousticGuitarnylon | AcousticGuitarsteel | 
 ElectricGuitarjazz | ElectricGuitarclean | 
 ElectricGuitarmuted | OverdrivenGuitar | 
 DistortionGuitar | GuitarHarmonics | 
 AcousticBass | ElectricBassfingered | 
 ElectricBasspicked | FretlessBass | 
 SlapBass1 | SlapBass2 | 
 SynthBass1 | SynthBass2 | 
 Violin | Viola | 
 Cello | Contrabass | 
 TremoloStrings | PizzicatoStrings | 
 OrchestralHarp | Timpani | 
 StringEnsemble1 | StringEnsemble2 | 
 SynthStrings1 | SynthStrings2 | 
 ChoirAahs | VoiceOohs | 
 SynthVoice | OrchestraHit | 
 Trumpet | Trombone | 
 Tuba | MutedTrumpet | 
 FrenchHorn | BrassSection | 
 SynthBrass1 | SynthBrass2 | 
 SopranoSax | AltoSax | 
 TenorSax | BaritoneSax | 
 Oboe | Bassoon | 
 EnglishHorn | Clarinet | 
 Piccolo | Flute | 
 Recorder | PanFlute | 
 BlownBottle | Shakuhachi | 
 Whistle | Ocarina | 
 Lead1square | Lead2sawtooth | 
 Lead3calliope | Lead4chiff | 
 Lead5charang | Lead6voice | 
 Lead7fifths | Lead8basslead | 
 Pad1newage | Pad2warm | 
 Pad3polysynth | Pad4choir | 
 Pad5bowed | Pad6metallic | 
 Pad7halo | Pad8sweep | 
 FX1train | FX2soundtrack | 
 FX3crystal | FX4atmosphere | 
 FX5brightness | FX6goblins | 
 FX7echoes | FX8scifi | 
 Sitar | Banjo | 
 Shamisen | Koto | 
 Kalimba | Bagpipe | 
 Fiddle | Shanai | 
 TinkleBell | Agogo | 
 SteelDrums | Woodblock | 
 TaikoDrum | MelodicDrum | 
 SynthDrum | ReverseCymbal | 
 GuitarFretNoise | BreathNoise | 
 Seashore | BirdTweet | 
 TelephoneRing | Helicopter | 
 Applause | Gunshot | Drums              deriving (Show, Eq, Enum)

